function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import { router } from 'dva';
var useDvaHistory = router.useHistory,
  useDvaLocation = router.useLocation,
  useRouteMatch = router.useRouteMatch,
  useParams = router.useParams;
export function getConvertedLocation(location) {
  return _objectSpread(_objectSpread({}, location), {}, {
    query: location.search.startsWith('?') ? location.search.slice(1).split('&').reduce(function (obj, str) {
      var _str$split = str.split('='),
        _str$split2 = _slicedToArray(_str$split, 2),
        k = _str$split2[0],
        v = _str$split2[1];
      return Object.assign(obj, _defineProperty({}, k, v));
    }, {}) : {}
  });
}
export function useLocation() {
  var location = useDvaLocation();
  return getConvertedLocation(location);
}
export function getConvertedHistory(location, history) {
  var jump = function jump(action) {
    return function (_path, state) {
      if (typeof _path === 'string') {
        return history[action](_path, state);
      }
      var search = Object.entries(_path.query || {}).map(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];
        return "".concat(k, "=").concat(encodeURI(v));
      }).join('&');
      return history[action](_objectSpread(_objectSpread({}, _path), {}, {
        search: search,
        state: state
      }));
    };
  };
  return _objectSpread(_objectSpread({}, history), {}, {
    location: location,
    push: jump('push'),
    replace: jump('replace')
  });
}
export function useHistory() {
  var location = useLocation();
  var history = useDvaHistory();
  return getConvertedHistory(location, history);
}
export { useRouteMatch, useParams };